/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.ClientToDspRecord;

import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ClientToDsp extends TableImpl<ClientToDspRecord> {

    private static final long serialVersionUID = 78219755;

    /**
     * The reference instance of <code>CLIENT_TO_DSP</code>
     */
    public static final ClientToDsp CLIENT_TO_DSP = new ClientToDsp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<ClientToDspRecord> getRecordType() {
        return ClientToDspRecord.class;
    }

    /**
     * The column <code>CLIENT_TO_DSP.ID</code>.
     */
    public final TableField<ClientToDspRecord, Integer> ID = createField("ID", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>CLIENT_TO_DSP.ANAG_CLIENT_ID</code>.
     */
    public final TableField<ClientToDspRecord, Integer> ANAG_CLIENT_ID = createField("ANAG_CLIENT_ID", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>CLIENT_TO_DSP.IDDSP</code>.
     */
    public final TableField<ClientToDspRecord, String> IDDSP = createField("IDDSP", org.jooq.impl.SQLDataType.VARCHAR(100), this, "");

    /**
     * The column <code>CLIENT_TO_DSP.LICENCE</code>.
     */
    public final TableField<ClientToDspRecord, String> LICENCE = createField("LICENCE", org.jooq.impl.SQLDataType.CLOB, this, "");

    /**
     * The column <code>CLIENT_TO_DSP.START_DATE</code>.
     */
    public final TableField<ClientToDspRecord, Timestamp> START_DATE = createField("START_DATE", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>CLIENT_TO_DSP.END_DATE</code>.
     */
    public final TableField<ClientToDspRecord, Timestamp> END_DATE = createField("END_DATE", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * Create a <code>CLIENT_TO_DSP</code> table reference
     */
    public ClientToDsp() {
        this(DSL.name("CLIENT_TO_DSP"), null);
    }

    /**
     * Create an aliased <code>CLIENT_TO_DSP</code> table reference
     */
    public ClientToDsp(String alias) {
        this(DSL.name(alias), CLIENT_TO_DSP);
    }

    /**
     * Create an aliased <code>CLIENT_TO_DSP</code> table reference
     */
    public ClientToDsp(Name alias) {
        this(alias, CLIENT_TO_DSP);
    }

    private ClientToDsp(Name alias, Table<ClientToDspRecord> aliased) {
        this(alias, aliased, null);
    }

    private ClientToDsp(Name alias, Table<ClientToDspRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> ClientToDsp(Table<O> child, ForeignKey<O, ClientToDspRecord> key) {
        super(child, key, CLIENT_TO_DSP);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CLIENT_TO_DSP_FK_CLIENT_TO_DSP_ANAG_CLIENT_ID_IDX, Indexes.CLIENT_TO_DSP_FK_CLIENT_TO_DSP_IDDSP_IDX, Indexes.CLIENT_TO_DSP_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<ClientToDspRecord, Integer> getIdentity() {
        return Keys.IDENTITY_CLIENT_TO_DSP;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<ClientToDspRecord> getPrimaryKey() {
        return Keys.KEY_CLIENT_TO_DSP_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<ClientToDspRecord>> getKeys() {
        return Arrays.<UniqueKey<ClientToDspRecord>>asList(Keys.KEY_CLIENT_TO_DSP_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<ClientToDspRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<ClientToDspRecord, ?>>asList(Keys.FK_CLIENT_TO_DSP_ANAG_CLIENT);
    }

    public AnagClient anagClient() {
        return new AnagClient(this, Keys.FK_CLIENT_TO_DSP_ANAG_CLIENT);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ClientToDsp as(String alias) {
        return new ClientToDsp(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public ClientToDsp as(Name alias) {
        return new ClientToDsp(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public ClientToDsp rename(String name) {
        return new ClientToDsp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public ClientToDsp rename(Name name) {
        return new ClientToDsp(name, null);
    }
}
